;; 8.7
;; Y-combinator
;; 171p
(defun fact (n) (if (zerop n) 1 (* n (fact (1- n)))))
(fact 5)
;; 172p
(defun mkfact () (lambda (n) (if (zerop n) 1 (* n (fact (1- n))))))
(funcall (mkfact) 5)

(defun mkfact2 (f) 
      (lambda (n) (if (zerop n) 1 (* n (funcall f (1- n))))))
(funcall (mkfact2 'fact) 5)

(defun mkfact3 (f)
  (lambda (n)
    (if (zerop n) 1 (* n (funcall (funcall f f) (1- n))))))
(funcall (mkfact3 'mkfact3) 5)

;; 173p
(defun Y (f n) (funcall (funcall f f) n))
(defun fact0 (f)
  (lambda (n) (if (zerop n) 1 (* n (Y f (1- n))))))
(funcall (fact0 'fact0) 5)

(Y 'fact0 5)

;; 174p
((lambda (f n) (funcall (funcall f f) n))
 '(lambda (f)
    (lambda (n)
      (if (zerop n)
      1
    (* n
       ((lambda (f n)
          (funcall (funcall f f) n)) f (1- n))))))
 5)

;; ő
(defun Y (f a b) (funcall (funcall f f) a b))
(defun mygcd (f)
  (lambda (a b)
    (if (zerop (mod a b)) b (Y f b (mod a b)))))
(Y 'mygcd 48 36)
((lambda (f a b) (funcall (funcall f f) a b))
 '(lambda (f)
    (lambda (a b)
      (if (zerop (mod a b))
      b
    ((lambda (f a b)
       (funcall (funcall f f) a b)) f b (mod a b)))))
 48
 36)

